# Agragar Z y Data a los par?metros
update_mu <- function(Data,mu,means,m,kw,z,variable)
{
  for(j in 1:length(mu[,1]))
  {
    if(m[j]!=0 & variable1[j]==T){mu[j,]<-(kw[j]*mu[j,]+m[j]*means[j,])/(kw[j]+m[j])}
    else if(length(which(z==0))>1){mu[j,]<-colMeans(Data[which(z==0),])}
    else{mu[j,]<-colMeans(Data)}
  }
  return(mu)
}

update_Tw <- function(x,y,Xbar,Ybar,z,Tw,mu,m)
{
  maxJ<-length(Tw)
  n<-length(x)
  S <- list(matrix(c(0,0,0,0),2,2))
  S <- rep(S,maxJ)
  for(i in 1:n)
  {
    if(z[i] != 0)
    {
      S[[z[i]]] <- S[[z[i]]] + matrix(c((x[i]-mu[[z[i]]][1])^2,(x[i]-mu[[z[i]]][1])*(y[i]-mu[[z[i]]][2]),
                                        (x[i]-mu[[z[i]]][1])*(y[i]-mu[[z[i]]][2]),(y[i]-mu[[z[i]]][2])^2)
                                      ,2,2)
    } 
  }
  j<-1
  for(j in 1:maxJ)
  {
    mu_n<-matrix((m[j]*c(Xbar[j],Ybar[j])+k*mu[[j]])/(m[j]+k[j]),1,2)
    Tw[[j]]<-solve( solve(Tw[[j]]) + S[[j]] + ((m[j]*k[j])/(m[j]+k[j]))*(crossprod(mu_n - c(Xbar[j],Ybar[j]))))
  }
  return(Tw)
}

update_alpha <- function(alpha,m)
{
  alpha<-alpha+m
  alpha[which(m==0)]<-0
  return(alpha)
}

update_Tw_v2<-function(Data,Tw,mu,kw,D,m,z,variable)
{
  for(j in 1:length(Tw))
  {
    if(m[j]>2 & variable[j]==T){Tw[[j]]<-update_Tw_j(Tw[[j]],mu[j,],kw[j],D[[j]],m[j])}
    else
    {
      if(length(which(z==0))<=2){Tw[[j]]<-matrix(c(1,0,0,1),2,2)}
      else{Tw[[j]]<-length(which(z==0))*matrix(solve(cov(Data[which(z==0),])),2,2)}
      
    }
  }
  return(Tw)
}

update_Tw_j<-function(Tw,mu,kw,D,m) ## This function should only be called if m[j]!=0
{
  ifelse(m<=2,A<-matrix(rep(0,4),2,2),A<-(m-1)*cov(D))
  return(solve(solve(Tw)+A+
            ((m*kw)/(m+kw))*tcrossprod(mu-c(mean(D[,1]),mean(D[,2])))))
}

update_v <- function(v,m,Mpr)
{
  res<-pmax(2,Mpr+m)
  res[which(m==0)]<-2
  #res<-v+m
  #res[which(m==0)]<-rep(2,length(which(m==0)))
  #res[which(m-Mpr< 0)]<-res[which(m-Mpr< 0)]+1
  #res[which(m-Mpr>=0)]<-res[which(m-Mpr>=0)]-1
  #res[which(res<2)]<-rep(2,length(which(res<2)))
  return(res)
}