for(l in 1:20000)
{
  #l<-l+1
  repeat
  {
    ## Variable
    variable1<-rep(TRUE,J)
    for(j in 2:J)
    {
      for(jj in 1:(j-1))
      {
        if(mahalanobis(theta[j,],theta[jj,],lambda[[jj]],inverted=T)<qchisq(.6,4))
        {
          if(dist(rbind(colMeans(Data),theta[j]))<dist(rbind(colMeans(Data),theta[jj]))){variable1[j]<-F}
          else{variable1[jj]<-F}
        }
      }
    }
    
    ## U, Z, D
    aux<-generate_Uv3(Data,theta,lambda,w,variable1)
    z<-aux[[1]]
    u<-aux[[2]]
    D<-aux[[3]]
    
    ## m and means
    means<-matrix(rep(NA,2*J),J,2);prevM<-m;m<-rep(0,J);
    for(j in 1:J){if(length(D[[j]])!=0){means[j,]<-colMeans(D[[j]]);m[j]<-length(D[[j]][,1])}}
    
    
    if(sum(m)/n>=.5)
    {
      break
    }
    else
    {
      for(j in 1:J)
      {
        if(variable1[j]==F | m[j]==0)
        {
          if(length(which(z==0))<=1)
            {theta[j,]<-rmvnorm(1,colMeans(Data),cov(Data))}
          else
            {theta[j,]<-rmvnorm(1,colMeans(Data[which(z==0),]),cov(Data))}
        }
      }
    }
  }
  
  ### Information criteria
  mh<-matrix(rep(0,n*J),n,J)
  
  for(i in 1:n)
  {
    for(j in 1:J)
    {
      mh[i,j]<-(det(lambda[[j]])^(1/2))*w[j]*exp(-(mahalanobis(Data[i,],theta[j,],lambda[[j]],inverted=T))/2)
    }
  }
  
  lkh<-(2*pi)^(-n)*prod(rowSums(mh))
  
  InfoCriteria$Loglikelihood[l]<-(-n*log(2*pi))+sum(log(rowSums(mh)))
  InfoCriteria$Akaike[l]<-(-2*InfoCriteria$Loglikelihood[l])+2*length(which(m!=0))*6
  InfoCriteria$Bayesian[l]<-(-2*InfoCriteria$Loglikelihood[l])+log(n)*length(which(m!=0))*6
  print(paste("Iteracin nmero ",l,"AIC: ",InfoCriteria$Akaike[l],", BIC: ",InfoCriteria$Bayesian[l],"LLd: ",InfoCriteria$Loglikelihood[l]))
  
  mu    <-update_mu(Data,mu,means,m,k,z,variable1)
  Tw    <-update_Tw_v2(Data,Tw,mu,k,D,m,z,variable1)
  v     <-update_v(v,m,prevM)
  alpha <-update_alpha(alpha,m)
  
  prevLambda<-lambda
  
  hist_theta[[l]]<-as.data.frame(theta)
  hist_lambda[[l]]<-data.frame(lamd_11=numeric(0),
                               lamd_22=numeric(0),
                               lamd_12=numeric(0))
  for(j in 1:J)
  {
    hist_lambda[[l]][j,1]<-lambda[[j]][1,1]
    hist_lambda[[l]][j,2]<-lambda[[j]][2,2]
    hist_lambda[[l]][j,3]<-lambda[[j]][1,2]
  }
  
  lambda <-update_lambda(Tw,v,variable1)
  theta  <-update_theta_v2(D,m,mu,k,theta,lambda,prevLambda,u,25,variable1)
  w      <-rdirichlet(1,alpha)
  alpha  <-m+1;k<-m/2
  k[which(m==0)]<-1
  results[l,]<-z
  
}
