
generate_Uv1 <- function(Data,theta,lambda,iter)
{
  z<-rep(0,length(Data[,1]))
  Da<-list()
  for(j in 1:length(lambda)){Da[[j]]<-data.frame()}
  bound <- 0;u<-0;j<-1;
  for(l in 1:iter)
  {
    for(j in 1:J)
    {
      j<-2
      Da[[j]]<-data.frame()
      bound[j]<-Inf
      for(i in 1:nrow(Data)){if(z[i]==j){z[i]<-0}}
      for(t in 1:J)
      {
        if(nrow(Da[[t]]) > 0)
        {
          #bound[j]<-min(c(bound[j],mahalanobis(theta[[j]],theta[[t]],lambda[[j]],
          #                                     inverted=TRUE)))
          for(i in 1:length(Da[[t]]))
            {
            bound[j]<-min(c(bound[j],mahalanobis(c(Da[[j]][i,1],Da[[j]][i,2]),
                                                                           theta[[j]],lambda[[j]],inverted=TRUE)))}
        }
      }
      u[j]<- rtrunc(1,spec="gamma",a=0,b=bound[j],shape=2,scale=2)
      for(i in 1:nrow(Data))
      {
        if(mahalanobis(Data[i,],theta[[j]],lambda[[j]],inverted=TRUE)<u[j])
        {
          Da[[j]]<-rbind(Da[[j]],Data[i,])
          z[i]<-j
        }
      }
    }
  }
  return(list(z,u,Da))
}

generate_Uv2 <- function(data,theta,lambda,w)
{
  N<-length(data[,1]);u<-rep(0,N);z<-rep(0,N)
  Da<-replicate(length(theta[,1]),data.frame())
  for(i in 1:N)
  {
    aux<-generate_Uv2_i(data[i,],theta,lambda,i,w)
    z[i]<-aux[[1]];u[i]<-aux[[2]]
    if(z[i]!=0){Da[[z[i]]]<-rbind(Da[[z[i]]],data[i,])}
  }
  return(list(z,u,Da))
}

# Receives a point, a center and a matrix and returns a u and a z 
generate_Uv2_i <- function(x,theta,lambda,i,w)
{
  J<-length(theta[,1]);
  distances<-rep(0,J);chi<-rchisq(J,4);cluster<-0
  for(j in 1:J)
  {
    distances[j]<-mahalanobis(Data[i,],theta[j,],lambda[[j]],inverted=T)
  }
  cluster<-which.max(w*exp(-distances/2))
  if((distances-chi)[cluster]>0){return(list(0,NA))}
  return(list(cluster,chi[cluster]))
}

generate_Uv3 <- function (data,theta,lambda,w,variable)
{
  N<-length(Data[,1]);u<-rep(0,N);z<-rep(0,N);bounds<-rep(Inf,J)
  Da<-replicate(length(theta[,1]),data.frame())
  for(j in 1:J)
  {
    for(k in 1:J)
    {
      if(j!=k & variable[k]==T){bounds[j]<-min(c(bounds[j],sqrt(mahalanobis(theta[j,],theta[k,],lambda[[j]]))))}
    }
  }
  for(i in 1:N)
  {
    aux<-generate_Uv3_i(Data[i,],theta,lambda,i,w,bounds,variable)
    z[i]<-aux[[1]];u[i]<-aux[[2]]
    if(z[i]!=0){Da[[z[i]]]<-rbind(Da[[z[i]]],Data[i,])}
  }
  return(list(z,u,Da))
}

generate_Uv3_i <- function(x,theta,lambda,i,w,bounds,variable)
{
  J<-length(theta[,1]);chi<-rep(0,J);
  distances<-rep(0,J);cluster<-0;
  for(j in 1:J)
  {
    #print(variable[j]==T)
    if(variable[j]==T)
    {
      chi[j]<-rtrunc(1,spec="gamma",shape=2,scale=2,a=0,b=bounds[j])
      distances[j]<-mahalanobis(Data[i,],theta[j,],lambda[[j]],inverted=T)
    }
    else
    {
      chi[j]<-NA;
      distances[j]<-Inf
    }
  }
  #cluster<-which.max(w*exp(-distances/2))
  cluster<-which.min(distances)
  if((distances-chi)[cluster]>0){return(list(0,NA))}
  return(list(cluster,chi[cluster]))
}


